/* The Waffle Cookie Press                                                 */
/* Version 1.1                                                             */

/* By Christopher Horn (chorn@eastwind.mcds.com)                           */
/* Compiled 8/4/92 under Borland C/C++ 3.0                                 */

/* The Cookie Press is a simple replacement cookie utility for Waffle.     */
/* It supports multi-line cookies, and can also permit anonymous sigs.     */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
                        /* Defines for special characters                  */

#define BS     8                                 /* Backspace              */
#define EM     25                                /* Ctrl-Y  (Delete line)  */
#define CR     13                                /* Carriage Return        */
#define SPACE  32                                /* Space                  */

                        /* Global variables                                */

char cookie[20][76];                   /* To hold the entered cookie       */
char uacct[8];                         /* User account                     */
int usec;                              /* User security level              */
char uname[30];                        /* User identity                    */

char fname[100];                       /* Filename                         */
FILE *fp;                              /* Our file pointer                 */
int i,j;                               /* Loop variables                   */
int cpos;                              /* Lines in entered cookie          */
char tmp[80], tmp2[80], *k;            /* Work string                      */
time_t dt;                             /* Structure to get date            */
char cdt[12];                          /* The current date                 */

char fpath[80] = "/waffle/";           /* Path to Waffle                   */
int climit = 4;                        /* Line limit for cookie            */
int cadd = 1;                          /* Secutity to add cookie           */
int canon = 5;                         /* Security to make anonymous       */
int cdate = 0;                         /* Add date to signature            */
int clog = 0;                          /* Write to admin log               */
int ccheck = 0;                        /* Check if really want entered     */
char cprompt[80] = "Enter cookie, but no bufu :";
char crem[80] = "Spoilsport. No cookie for you.";
char cask[80] = "Is the cookie good?";

                        /* Function prototypes                             */

void gdate(void);                 /* Get current date                      */
void dispcook(void);              /* Display a cookie                      */
void getcook(void);               /* Get a cookie                          */
int getstr(char *st, int maxlen); /* Get a string                          */
void getcnf(void);                /* Get configuration info if available   */
void wcookie(void);               /* Append to cookie file                 */
void clist(void);                 /* List cookies                          */
void frerr(void);                 /* File read error                       */
void fwerr(void);                 /* File write error                      */


int main(int argc, char *argv[])
{
  if (argc<4)		/* Someone forgot to call with the arguements	   */
  {
    printf("\nThe Waffle Cookie Press\nVersion 1.0\n\nCommand line syntax"
           " :\nCOOKIE %A %a [%i] %W\n\nwhere :\n%A is the user account\n"
           "%a is the access level\n%i is the extra argument data\n"
           "%W is the user identity\n\n");
    exit(0);
  }

  strcpy(uacct,argv[1]);               /* Get account name		   */
  usec = atoi(argv[2]);		       /* Get level			   */
  strupr(argv[3]);                     /* Check if want the list           */
  if (strcmp(argv[3],"[LIST]") == 0) clist();
  if (strcmp(argv[3],"[JAR]") == 0) clist();
  strcpy(uname,"");
  for(i=4; i<argc; i++)                /* Get identity                     */
  {
    strcat(uname,argv[i]);
    if (i != argc-1) strcat(uname," ");
  }

  gdate();                             /* Get date                         */
  getcnf();                            /* Get config info if available     */
  dispcook();                          /* Display a cookie                 */
  getcook();                           /* Get a cookie                     */
  printf("\n\n");
  return(0);
}


/*-------------------------------------------------------------------------*/
/* gdate  Get current date                                                 */

void gdate(void)
{
  dt = time(NULL);
  strcpy(tmp,ctime(&dt));
  strncpy(cdt,tmp+8,2);
  strcat(cdt,"-");
  strncat(cdt,tmp+4,3);
  strcat(cdt,"-");
  strncat(cdt,tmp+22,2);
}


/*-------------------------------------------------------------------------*/
/* dispcook  Display a cookie                                              */

void dispcook(void)
{
  char ch;

  strcpy(fname,fpath);
  strcat(fname,"system/cookies");
  if((fp = fopen(fname,"r")) == NULL) return;
  i = 0;
  while(!feof(fp))
  {
    fscanf(fp,"%[^|]",cookie);
    if (getc(fp) == EOF) break;
    i++;
  }

  randomize();
  i = random(i);
  rewind(fp);
  for(j=0; j<i; j++)
  {
    if (fscanf(fp,"%[^|]",cookie) == EOF) return;
    if (getc(fp) == EOF) return;
  }

  do {
    ch = getc(fp);
    if (ch == '|') break;
    printf("%c",ch);
  } while (!feof(fp));

  fclose(fp);
  printf("\n");
}


/*-------------------------------------------------------------------------*/
/* getcook  Get a cookie                                                   */

void getcook(void)
{
  if (usec < cadd) return;
  printf("\n%s",cprompt);
  for(cpos=0; cpos < climit; cpos++)
  {
    printf("\n");
    if((getstr(cookie[cpos],75)) == 0) break;
  }
  if (cpos == 0)
  {
    printf("\n\n%s\n",crem);
    return;
  }
  if (ccheck)
  {
    printf("\n\n%s ",cask);
    getstr(tmp,3);
    if (toupper(tmp[0]) != 'Y') return;
  }
  if (usec < canon)
  {
    strcpy(cookie[cpos],"                                   [");
    strcat(cookie[cpos],uname);
    if (cdate)
    {
      strcat(cookie[cpos],",");
      strcat(cookie[cpos],cdt);
    }
    strcat(cookie[cpos],"]");
  } else cpos--;
  wcookie();
}


/*-------------------------------------------------------------------------*/
/* getcnf  Get configuration info if a config file exists		   */

void getcnf(void)
{
  strcpy(tmp,getenv("WAFFLE"));
  if (strlen(tmp) > 1)
  {
    k = tmp;
    for(i=0;i<strlen(tmp)-6;i++) k++;
    *k = 0;
    strcpy(fname,tmp);
  } else strcpy(fname,"/waffle/system/");
  strcat(fname,"cookie.cfg");

  if((fp = fopen(fname,"r")) != NULL)
  {
    while(!feof(fp))
    {
      fscanf(fp,"%[^\n]",tmp);
      if ((i = getc(fp)) == EOF) break;
      strcpy(tmp2,tmp);
      strupr(tmp);
      if(!strncmp("CPATH=",tmp,6)) strcpy(fpath,tmp+6);
      if(!strncmp("CPROMPT=",tmp,8)) strcpy(cprompt,tmp2+8);
      if(!strncmp("CREM=",tmp,5)) strcpy(crem,tmp2+5);
      if(!strncmp("CASK=",tmp,5)) strcpy(cask,tmp2+5);
      if(!strncmp("CLIMIT=",tmp,7))
      {
	strcpy(tmp2,tmp+7);
	if((climit = atoi(tmp2)) < 1) climit = 1;
	  else if(climit > 19) climit = 19;
      }
      if(!strncmp("CANON=",tmp,6))
      {
	strcpy(tmp2,tmp+6);
	if((canon = atoi(tmp2)) < 0) canon = 0;
	 else if(canon > 9) canon = 9;
      }
      if(!strncmp("CADD=",tmp,5))
      {
	strcpy(tmp2,tmp+5);
	if((cadd = atoi(tmp2)) < 0) cadd = 0;
	 else if(cadd > 9) cadd = 9;
      }
      if(!strncmp("CLOG=",tmp,5))
        if(toupper(tmp[5]) == 'Y') clog = 1;
      if(!strncmp("CCHECK=",tmp,7))
        if(toupper(tmp[7]) == 'Y') ccheck = 1;
      if(!strncmp("CDATE=",tmp,6))
        if(toupper(tmp[6]) == 'Y') cdate = 1;
    }
    fclose(fp);
  }
}


/*-------------------------------------------------------------------------*/
/* wcookie  Append new entry to cookie file                                */

void wcookie(void)
{
  strcpy(fname,fpath);
  strcat(fname,"system/cookies");
  if ((fp = fopen(fname, "a")) == NULL) fwerr();
  for (i=0; i<=cpos; i++)
  {
    fprintf(fp,"%s",cookie[i]);
    if (i < cpos) fprintf(fp,"\n");
  }
  fprintf(fp,"|\n");
  fclose(fp);
  if (clog == 0) return;

  strcpy(fname,fpath);
  strcat(fname,"admin/cookies");
  if ((fp = fopen(fname, "a")) == NULL) fwerr();
  fprintf(fp,"\n");
  for (i=0; i<=cpos; i++)
  {
    fprintf(fp,"%s",cookie[i]);
    if (i < cpos) fprintf(fp,"\n");
  }
  fprintf(fp,"|\n");
  fprintf(fp,"%s (%s)\n",uacct,uname);
  fclose(fp);
}


/*-------------------------------------------------------------------------*/
/* clist  Cookie list                                                      */

void clist(void)
{
  getcnf();
  strcpy(fname,fpath);
  strcat(fname,"system/cookies");
  if((fp = fopen(fname,"r")) == NULL) frerr();
  i = 0;
  while (fscanf(fp,"%[^\n]",tmp) != EOF)
  {
    if (getc(fp) == EOF) break;
    printf("%s\n",tmp);
    if (++i > 23)
    {
      printf("[more]");
      getch();
      printf("\b \b\b \b\b \b\b \b\b \b\b \b");
      i = 0;
    }
  }
  fclose(fp);
  printf("\n");
  exit(0);
}


/*-------------------------------------------------------------------------*/
/* frerr  Report a file open for read i/o error and abort program	   */

void frerr(void)
{
  printf("\n\n\nError : Unable to open %s for reading\n\n",fname);
  exit(0);
}


/*-------------------------------------------------------------------------*/
/* fwerr  Report file open for write i/o error and abort program           */

void fwerr(void)
{
  printf("\n\n\nError : Unable to open %s for writing\n\n",fname);
  exit(0);
}


/*-------------------------------------------------------------------------*/
/* getstr  Gets a string from the user. Can only be maxlen long. Ctrl-H    */
/* is backspace, Ctrl-Y clears the line.				   */

int getstr(char *st,int maxlen)
{
  int lp, len, ch;

  for (lp=0; lp<maxlen+1; lp++) putchar(SPACE);
  putchar(93);
  lp++;
  for (; lp>0; lp--) putchar(BS);
  putchar(91);
  len = 0;

  while ((ch=getch())!=CR)
  {
    if (ch==BS)          	        /* Handle backspace                */
    {
      if(len>0)
      {
	len--;
	st--;
	putchar(BS);
	putchar(SPACE);
	putchar(BS);
      }
    }
    else
    if (ch==EM)			        /* Handle delete line              */
    {
      for(; len>0; len--)
      {
	st--;
	putchar(BS);
	putchar(SPACE);
	putchar(BS);
      }
    }
    else
    if (len < maxlen)
    {                             	/* Good character, put in string   */
      *st++ = ch;
      len++;
      putchar(ch); 			/* And display it		   */
    }
  }
  *st=0;                                /* Terminate the string       	   */
  return len;				/* Return the length		   */
}

